/* Copyright 2013 Andrey Dubovik <andrei.dubovik@gmail.com>
 *
 * This file is part of Minido.
 *
 * Minido is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Minido is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Minido. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef APPLICATIONS_HPP
#define APPLICATIONS_HPP

#include <memory>
#include <map>

#include "database.hpp"

class Application: public Item {
public:
  std::string exec;
  Application(DataBase& db);
  void invoke();
};

typedef std::map<std::string, std::unique_ptr<Application>> Collection;

extern "C" {
  void populate(DataBase& db);
}

std::string parseExec(const std::string& str);

void loadFile(const std::string& filename);

void loadDir(const std::string& dirname);

#endif

