/* Copyright 2013 Andrey Dubovik <andrei.dubovik@gmail.com>
 *
 * This file is part of Minido.
 *
 * Minido is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Minido is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Minido. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef UTILITIES_HPP
#define UTILITIES_HPP
#include <string>
#include "database.hpp"

template<class T>
void replace(T& str, const T& from, const T& to) {
  for(auto cur = str.find(from); cur != T::npos;
      cur = str.find(from, cur + to.size())) {
    str.replace(cur, from.size(), to);
  }
}

void sanitize(std::string& str);
void sanitize(std::u32string& str);

std::string decorate(const std::string& str, const std::string& style);
std::string decorate(const std::u32string& str, const std::string& style);

std::string decorate(const std::u32string& str, const std::string& style, const MatchMask& mask);


#endif
